#include "_stralloc.h"
#include "_scan.h"
#include "_ip4.h"
#include "socket.h"
#include "bailout.h"
#include "error.h"
#include "doconnect.h"
#include "timeoutconn.h"
#include "str.h"
#include "dns.h"
#include "byte.h"

int 
doconnect(const char *host)
{
	int sock;
	int l;
	int l2;
	char ip[4];
	unsigned long port;

	l=ip4_scan(host,ip);
	if (l==0) {
		stralloc addresses=STRALLOC_INIT;
		stralloc fqdn=STRALLOC_INIT;
		stralloc tmp=STRALLOC_INIT;
		l=str_chr(host,':');
		if (!stralloc_copyb(&tmp,host,l))
			xbailout(111,0,"out of memory",0,0,0);
		if (dns_ip4_qualify(&addresses,&fqdn, &tmp) == -1)
			xbailout(111,errno,
				"fatal: temporarily unable to figure out IP address for ",
				host,0,0);
		if (addresses.len < 4)
			xbailout(100,0,"fatal: no IP address for ",host,0,0);
		byte_copy(ip,4,addresses.s);
		stralloc_free(&addresses);
		stralloc_free(&fqdn);
		stralloc_free(&tmp);
	}
	if (host[l]==':') {
		l++;
		l2=scan_ulong(host+l,&port);
		if (l2==0) bailout(0,"cannot parse ",host,0,0);
		if (host[l+l2]) bailout(0,"cannot parse ",host,0,0);
	} else
		port=21;
	sock=socket_tcp();
	if (sock==-1) bailout(errno,"cannot create socket",0,0,0);
	if (-1==timeoutconn(sock,ip,port,30))
		bailout(errno,"cannot connect socket",0,0,0);
	return sock;
}

